using Microsoft.ML;
using System;

namespace TestLibrary
{
    /// <summary>
    ///  Һ
    /// </summary>
    public class ConsumeModel
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        ///   LAZY
        /// </summary>
        private static Lazy<PredictionEngine<ModelInput, ModelOutput>> _predictionEngineLazy = new Lazy<PredictionEngine<ModelInput, ModelOutput>>(CreatePredictionEngine);

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Public

        #region   ϱ - CreatePredictionEngine()

        /// <summary>
        ///   ϱ
        /// </summary>
        /// <returns> </returns>
        public static PredictionEngine<ModelInput, ModelOutput> CreatePredictionEngine()
        {
            MLContext context = new MLContext();

            string filePath = @"WEIGHT\MLModel.zip";

            ITransformer mlModel = context.Model.Load(filePath, out var modelInputSchema);

            PredictionEngine<ModelInput, ModelOutput> predictionEngine = context.Model.CreatePredictionEngine<ModelInput, ModelOutput>(mlModel);

            return predictionEngine;
        }

        #endregion
        #region ϱ - Predict(input)

        /// <summary>
        /// ϱ
        /// </summary>
        /// <param name="input"> Է</param>
        /// <returns> </returns>
        public static ModelOutput Predict(ModelInput input)
        {
            ModelOutput result = _predictionEngineLazy.Value.Predict(input);

            return result;
        }

        #endregion
    }
}